import { StdFee } from "@cosmjs/launchpad";
import { DeliverTxResponse } from "@cosmjs/stargate";
import { EncodeObject, GeneratedType, OfflineSigner, Registry } from "@cosmjs/proto-signing";
import { IgniteClient } from "../client";
import { Api } from "./rest";
import { MsgCreateConfirmation } from "./types/rarimocore/tx";
import { MsgCreateTransferOp } from "./types/rarimocore/tx";
import { MsgCreateChangeKeyECDSA } from "./types/rarimocore/tx";
export { MsgCreateConfirmation, MsgCreateTransferOp, MsgCreateChangeKeyECDSA };
declare type sendMsgCreateConfirmationParams = {
    value: MsgCreateConfirmation;
    fee?: StdFee;
    memo?: string;
};
declare type sendMsgCreateTransferOpParams = {
    value: MsgCreateTransferOp;
    fee?: StdFee;
    memo?: string;
};
declare type sendMsgCreateChangeKeyECDSAParams = {
    value: MsgCreateChangeKeyECDSA;
    fee?: StdFee;
    memo?: string;
};
declare type msgCreateConfirmationParams = {
    value: MsgCreateConfirmation;
};
declare type msgCreateTransferOpParams = {
    value: MsgCreateTransferOp;
};
declare type msgCreateChangeKeyECDSAParams = {
    value: MsgCreateChangeKeyECDSA;
};
export declare const registry: Registry;
interface TxClientOptions {
    addr: string;
    prefix: string;
    signer?: OfflineSigner;
}
export declare const txClient: ({ signer, prefix, addr }?: TxClientOptions) => {
    sendMsgCreateConfirmation({ value, fee, memo }: sendMsgCreateConfirmationParams): Promise<DeliverTxResponse>;
    sendMsgCreateTransferOp({ value, fee, memo }: sendMsgCreateTransferOpParams): Promise<DeliverTxResponse>;
    sendMsgCreateChangeKeyECDSA({ value, fee, memo }: sendMsgCreateChangeKeyECDSAParams): Promise<DeliverTxResponse>;
    msgCreateConfirmation({ value }: msgCreateConfirmationParams): EncodeObject;
    msgCreateTransferOp({ value }: msgCreateTransferOpParams): EncodeObject;
    msgCreateChangeKeyECDSA({ value }: msgCreateChangeKeyECDSAParams): EncodeObject;
};
interface QueryClientOptions {
    addr: string;
}
export declare const queryClient: ({ addr }?: QueryClientOptions) => Api<unknown>;
declare class SDKModule {
    query: ReturnType<typeof queryClient>;
    tx: ReturnType<typeof txClient>;
    registry: Array<[string, GeneratedType]>;
    constructor(client: IgniteClient);
    updateTX(client: IgniteClient): void;
}
declare const Module: (test: IgniteClient) => {
    module: {
        RarifyprotocolRarimocoreRarimocore: SDKModule;
    };
    registry: [string, GeneratedType][];
};
export default Module;
